/* eslint-disable */
/**
 * This file was automatically generated by json-schema-to-typescript.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
 * and run json-schema-to-typescript to regenerate this file.
 */

export interface _Master_ {
  KiaraModelTypeInfo: KiaraModelTypeInfo;
}
/**
 * Base class that holds/manages information about an item within kiara.
 */
export interface KiaraModelTypeInfo {
  /**
   * The registered name for this item type.
   */
  type_name: string;
  /**
   * Documentation for the item.
   */
  documentation: Documentation;
  /**
   * Information about authorship for the item.
   */
  authors: Authors;
  /**
   * Generic properties of this item (description, tags, labels, references, ...).
   */
  context: Context;
  /**
   * The python class that implements this module type.
   */
  python_class: PythonClass;
  /**
   * The (json) schema for this model data.
   */
  metadata_schema: {
    [k: string]: unknown;
  };
}
/**
 * Documentation about a resource.
 */
export interface Documentation {
  /**
   * Short description of the item.
   */
  description?: string;
  /**
   * Detailed documentation of the item (in markdown).
   */
  doc?: string;
}
/**
 * Information about all authors of a resource.
 */
export interface Authors {
  /**
   * The authors/creators of this item.
   */
  authors?: Author[];
  [k: string]: unknown;
}
/**
 * Details about an author of a resource.
 */
export interface Author {
  /**
   * The full name of the author.
   */
  name: string;
  /**
   * The email address of the author
   */
  email?: string;
}
/**
 * Information about the context of a resource.
 */
export interface Context {
  /**
   * References for the item.
   */
  references?: {
    [k: string]: Link;
  };
  /**
   * A list of tags for the item.
   */
  tags?: string[];
  /**
   * A list of labels for the item.
   */
  labels?: {
    [k: string]: string;
  };
  [k: string]: unknown;
}
/**
 * A description and url for a reference of any kind.
 */
export interface Link {
  /**
   * The url.
   */
  url: string;
  /**
   * A short description of the link content.
   */
  desc?: string;
}
/**
 * Python class and module information.
 */
export interface PythonClass {
  /**
   * The name of the Python class.
   */
  python_class_name: string;
  /**
   * The name of the Python module this class lives in.
   */
  python_module_name: string;
  /**
   * The full class namespace.
   */
  full_name: string;
}
